#include <stdio.h>


double s1(const double a1, const double *const b, const int n, const double x1) {
  int j;
  double sum = 0.0;
  for (j = n; j >= 1; --j)
    sum = sum * x1 + (a1 + b[j - 1]);
  return sum;
}

double h1(const double *const a, const double *const b, const int n, const double x) {
  int i;
  double prod = 1.0, xpot = x * x;
  for (i = 1; i <= n; ++i) {
    prod *= xpot * s1(a[i - 1], b, n, x);
    xpot *= x;
  }
  return prod;
}


double s2(const double *const c, const double d1, const int m, const double y1) {
  int i;
  double sum1 = 0.0;
  for (i = m; i >= 1; --i)
    sum1 = sum1 * y1 + (c[i - 1] * d1);
  return sum1;
}

double h2(const double *const c, const double *const d, const int m, const double y) {
  int j;
  double sum = 0.0, ypot = y;
  for (j = 1; j <= m; ++j) {
    sum += ypot * s2(c, d[j - 1], m, y);
    ypot *= y;
  }
  return sum;
}


double s3(const double e1, const double *const f, const int m, const double u1) {
  int i;
  double sum = 0.0;
  for (i = m; i >= 1; --i)
    sum = sum * u1 + (e1 - f[m - i]);
  return sum;
}

double h3(const double *const e, const double *const f, const int m, const double u) {
  int j;
  double prod = 1.0, upot = u;
  for (j = 1; j <= m; ++j) {
    prod *= upot * s3(e[m - j], f, m, u);
    upot *= u;
  }
  return prod;
}


double s4(const double p1, const double *const q, const int n, const double v1) {
  int j;
  double sum1 = 0.0;
  for (j = n; j >= 1; --j)
    sum1 = sum1 * v1 + (p1 / q[n - j]);
  return sum1;
}

double h4(const double *const p, const double *const q, const int n, const double v) {
  int i;
  double sum = 0.0, vpot = v * v;
  for (i = 1; i <= n; ++i) {
    sum += vpot * s4(p[n - i], q, n, v);
    vpot *= v;
  }
  return sum;
}


int main(void) {
  int k, l;
  double r[17], s[17];
  double w;
  printf("Duljina nizova: ");
  scanf("%d", &l);
  printf("Niz 1: ");
  for (k = 0; k < l; ++k)
    scanf("%lg", r + k);
  printf("Niz 2: ");
  for (k = 0; k < l; ++k)
    scanf("%lg", s + k);
  printf("Argument: ");
  scanf("%lg", &w);
  printf("h1 = %g\n", h1(r, s, l, w));
  printf("h2 = %g\n", h2(r, s, l, w));
  printf("h3 = %g\n", h3(r, s, l, w));
  printf("h4 = %g\n", h4(r, s, l, w));
  return 0;
}
