#include <stdio.h>
#include <limits.h>

// -------------------------- Grupa A --------------------------
int brDjelitelja( int x )
{
	int i, brDj = 0;

	x = ( x < 0 ) ? -x : x;
	if( x == 0 )
		return INT_MAX;
		
	for( i = 1; i <= x; ++i )
		if( x % i == 0 )
			++brDj;
			
	return brDj;
}

void sortA( int niz[], int n )
{
	int i, j, tmp;
	
	for( i = 0; i < n; ++i )
		for( j = i+1; j < n; ++j )
			if( mijau( niz[ i ] ) > mijau( niz[ j ] ) ||
			    mijau( niz[ i ] ) == mijau( niz[ j ] ) && brDjelitelja( niz[ i ] ) < brDjelitelja( niz[ j ] ) )
			{
				tmp = niz[ i ];
				niz[ i ] = niz[ j ];
				niz[ j ] = tmp;
			}
}

int mainA( void )
{
	int X[ 111 ], A, B, i, lo = 0, hi = 110, mid, index = -1;
	
	for( i = 0; i < 111; ++i )
		scanf( "%d", &X[ i ] );
	scanf( "%d%d", &A, &B );
		
	sortA( X, 111 );
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		if( mijau( X[ mid ] ) == A && brDjelitelja( X[ mid ] ) == B )
		{
			index = mid;
			break;
		}
		else if( mijau( X[ mid ] ) > A || 
		         mijau( X[ mid ] ) == A && brDjelitelja( X[ mid ] ) < B )
			hi = mid - 1;
		else
			lo = mid + 1;
	}
	
	printf( "%d\n", index );

	return 0;
}

// -------------------------- Grupa B --------------------------
int brProstihDjelitelja( int x )
{
	int i = 2, brDj = 0;

	x = ( x < 0 ) ? -x : x;
	if( x == 0 )
		return INT_MAX;
		
	while( x > 1 )
	{
		if( x % i == 0 )
			++brDj;
		while( x % i == 0 )
			x /= i;
			
		++i;
	}

	return brDj;
}

void sortB( int niz[], int n )
{
	int i, j, tmp;
	
	for( i = 0; i < n; ++i )
		for( j = i+1; j < n; ++j )
			if( ciju( niz[ i ] ) < ciju( niz[ j ] ) ||
			    ciju( niz[ i ] ) == ciju( niz[ j ] ) && brProstihDjelitelja( niz[ i ] ) > brProstihDjelitelja( niz[ j ] ) )
			{
				tmp = niz[ i ];
				niz[ i ] = niz[ j ];
				niz[ j ] = tmp;
			}
}

int mainB( void )
{
	int Y[ 313 ], C, D, i, lo = 0, hi = 312, mid, index = -1;
	
	for( i = 0; i < 313; ++i )
		scanf( "%d", &Y[ i ] );
	scanf( "%d%d", &C, &D );
		
	sortB( Y, 313 );
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		if( ciju( Y[ mid ] ) == C && brProstihDjelitelja( Y[ mid ] ) == D )
		{
			index = mid;
			break;
		}
		else if( ciju( Y[ mid ] ) < C || 
		         ciju( Y[ mid ] ) == C && brProstihDjelitelja( Y[ mid ] ) > D )
			hi = mid - 1;
		else
			lo = mid + 1;
	}
	
	printf( "%d\n", index );

	return 0;
}

// -------------------------- Grupa C --------------------------
int brSlozenihDjelitelja( int x )
{
	if( x == 0 )
		return INT_MAX;
	else
		return brDjelitelja( x ) - brProstihDjelitelja( x ) - 1;
}

void sortC( int niz[], int n )
{
	int i, j, tmp;
	
	for( i = 0; i < n; ++i )
		for( j = i+1; j < n; ++j )
			if( vuf( niz[ i ] ) > vuf( niz[ j ] ) ||
			    vuf( niz[ i ] ) == vuf( niz[ j ] ) && brSlozenihDjelitelja( niz[ i ] ) < brSlozenihDjelitelja( niz[ j ] ) )
			{
				tmp = niz[ i ];
				niz[ i ] = niz[ j ];
				niz[ j ] = tmp;
			}
}

int mainC( void )
{
	int Z[ 515 ], E, F, i, lo = 0, hi = 110, mid, index = -1;
	
	for( i = 0; i < 515; ++i )
		scanf( "%d", &Z[ i ] );
	scanf( "%d%d", &E, &F );
		
	sortC( Z, 515 );
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		if( vuf( Z[ mid ] ) == E && brSlozenihDjelitelja( Z[ mid ] ) == F )
		{
			index = mid;
			break;
		}
		else if( vuf( Z[ mid ] ) > E || 
		         vuf( Z[ mid ] ) == E && brSlozenihDjelitelja( Z[ mid ] ) < F )
			hi = mid - 1;
		else
			lo = mid + 1;
	}
	
	printf( "%d\n", index );

	return 0;
}

// -------------------------- Grupa D --------------------------
int brProstihZnamenki( int x )
{
	int brPrZnam = 0;
	x = ( x < 0 ) ? -x : x;

	while( x != 0 )
	{
		int znam = x % 10;
		if( znam == 2 || znam == 3 || znam == 5 || znam == 7 )
			++brPrZnam;
			
		x /= 10;
	}
	
	return brPrZnam;
}

void sortD( int niz[], int n )
{
	int i, j, tmp;
	
	for( i = 0; i < n; ++i )
		for( j = i+1; j < n; ++j )
			if( iaaa( niz[ i ] ) < iaaa( niz[ j ] ) ||
			    iaaa( niz[ i ] ) == iaaa( niz[ j ] ) && brProstihZnamenki( niz[ i ] ) > brProstihZnamenki( niz[ j ] ) )
			{
				tmp = niz[ i ];
				niz[ i ] = niz[ j ];
				niz[ j ] = tmp;
			}
}

int mainD( void )
{
	int W[ 717 ], G, H, i, lo = 0, hi = 312, mid, index = -1;
	
	for( i = 0; i < 717; ++i )
		scanf( "%d", &W[ i ] );
	scanf( "%d%d", &G, &H );
		
	sortD( W, 717 );
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		if( iaaa( W[ mid ] ) == G && brProstihZnamenki( W[ mid ] ) == H )
		{
			index = mid;
			break;
		}
		else if( iaaa( W[ mid ] ) < G || 
		         iaaa( W[ mid ] ) == G && brProstihZnamenki( W[ mid ] ) > H )
			hi = mid - 1;
		else
			lo = mid + 1;
	}
	
	printf( "%d\n", index );

	return 0;
}


// -------------------------------------------------------------
int main( void )
{
	char ch;
	
	scanf( "%c", &ch );
	switch( ch )
	{
		case 'A' : mainA(); break;
		case 'B' : mainB(); break;
		case 'C' : mainC(); break;
		case 'D' : mainD(); break;
		default  : printf( "A ili B ili C ili D\n" );
	}

	return 0;
}
